--[[
--
--
--
--
--
--
--
--
--
]]
io.stdout:setvbuf("no")
local loader = require("libs.loader")
anim8 = require("libs.anim8")
require("libs.secs")
require("sprite")
require("phys")
require("mapFunctions.mapUtil")
sti = require("libs.tiledLoader")
gamera = require 'libs.gamera'
Input = require 'libs.input'


local LightWorld = require "libs"
     lightWorld = LightWorld({
    ambient = {0 ,0,0},
    refractionStrength = 12.0,
    reflectionVisibility = 0.9,
  })



--These two arrays will store all actual images and sounds within them.
players = {}
mapSets = {}
mapNormal = {}
currentMaps = {}



local sounds = {}


--this array stores all the sprites, graphical objects, in the game
spriteList = {}
cam = {}

local finishedLoading = false

function limitNum(tx,ty)
   if tx>ty then
      return ty
   end
   if tx<-ty then
      return -ty
   end
   return tx
end



function addSprite(n,l)
   spriteList[n] =l;
end
function deleteSprite(n)
   spriteList[n] = nil;
end
function newCam(tx,ty)
   cam = gamera.new(0,0,tx,ty)
end


function gameFinishedLoading()




   require("mapFunctions.mapLoaders")
   require("player")


   p1= player:new()
   p1.name = "p1"
   addSprite(p1.name, p1)
   p1.x = 400
   p1.y = 700
   changeMap('garden2', 'top')



   cam = gamera.new(0,0,curMap.width*25,curMap.height*25)
   -- create light
   lightMouse = lightWorld:newLight(0, 0, 255, 127, 63, 300)
   lightMouse:setGlowStrength(0.3)
    lightMouse.normalInvert = true

   min_dt = 1/60
   next_time = love.timer.getTime()




   if arg[#arg] == "-debug" then require("mobdebug").start() end
end


function math.rd(num)
    return math.floor(num+0.5)
end



----
---LOVE FUNCTIONS BELOW
----

--This function is called exactly once at the beginning of the game.
--@param(arg : unknown) A sequence strings which are command line arguments given to the game
function love.load(arg)

   input = Input()

   input:bind('left', 'left')
   input:bind('right', 'right')
   input:bind(' ', 'roll')
   input:bind('up', 'jump')
   input:bind('down', 'down')
   input:bind('c', 'magnet')


   input:bind('j', 'testLeft')
   input:bind('k', 'testDown')
   input:bind('l', 'testRight')
   input:bind('i', 'testUp')




   --Load the loader which caches objects
   loader.newImage(  players, 'default', 'sprites/default.png')
   loader.newImage(  players, 'temp', 'sprites/tempPlay.png')
   --loader.newImage(  players, 'tempNormal', 'sprites/tempPlayNormal.png')
   loader.newImage(  mapSets, 'collisionTiles', 'sprites/collisionTiles.png')
   loader.newImage(  mapSets, 'testMapTiles', 'sprites/testMapTiles.png')
   loader.newImage(  mapSets, 'testTilesGrass', 'sprites/testTilesGrass.png')

   loader.start(
      function()
         finishedLoading = true
      end
   )



end

--Callback function used to draw on the screen every frame.
function love.draw()
  -- map.layers.CD.opacity = 0 ;


      if finishedLoading == true then


         cam:draw(function(l,t,w,h)
                --lightWorld:draw(function()
                  love.graphics.setColor(255, 255, 255)
                  love.graphics.rectangle("fill", -x/1, -y/1, love.graphics.getWidth()*50, love.graphics.getHeight()*50)

                  curMap:setDrawRange(x, y, 1280 , 720)
                  curMap:draw(nil,nil,false)


                  for nam, spr in pairs(spriteList) do
                     if spr.hasAni then
                        spr.anis.animation.flippedH = spr.faceLeft
                        spr.anis.x = spr.x
                        spr.anis.y = spr.y
                        spr.anis:drawAnimation(spr.rot)
                     else

                     end
                  end

                  curMap:draw(nil,nil,true)
           -- end)
         end)

    local cur_time = love.timer.getTime()
            if next_time <= cur_time then
            next_time = cur_time
            return
         end
     love.timer.sleep(next_time - cur_time)
   end

end

--Callback function used to update the state of the game every frame.
--@param(dt : number) The duration of the previous frame
function love.update(dt)
   love.window.setTitle("A game FPS: ".. love.timer.getFPS())
   if not finishedLoading then
      loader.update() -- You must do this on each iteration until all resources are loaded
      if finishedLoading then
         gameFinishedLoading()
      end
   else
      next_time = next_time + min_dt




      for nam, spr in pairs(spriteList) do
         if spr.hasAni then
            spr.anis:update(1/60);
         else

         end
         spr:update(dt)
      end

      curMap:update(dt)

      --lightWorld:update(dt)
      --lightWorld:setTranslation(640-cam.x,360-cam.y,cam:getScale());
      --lightMouse:setPosition( cam:toWorld(love.mouse.getX() ,love.mouse.getY() ) )

      handleParallax()
   end

   input:update(dt)
end

--Callback function triggered when window receives or loses focus
--@param(f : boolean) window focus
function love.focus(f)

end

--Called when a joystick button is pressed
--@param(joystick : Joystick) The joystick number
--@param(button : number) The button number
function love.joystickpressed(joystick,button)
   input:gamepadpressed(joystick, button)
end

--Called when a joystick button is released
--@param(joystick : Joystick) The joystick
--@param(button : number) The button number
function love.joystickreleased(joystick,button)
   input:gamepadreleased(joystick, button)
end

function love.joystickaxis(joystick, axis, value )
   input:gamepadaxis(joystick, axis, value)
end
--Callback function triggered when a key is pressed.
--@param(key : string) Character of the key pressed (KeyConstant enumeration)
--@param(isrepeat : boolean) Whether this keypress event is a repeat.
function love.keypressed(key,isrepeat)
   input:keypressed(key)
end

--Callback function triggered when a key is released.
--@param(key : string) Character of the key released (KeyConstant enumeration)
function love.keyreleased(key)
   input:keyreleased(key)
end

--Callback function triggered when a mouse button is pressed.
--@param(x : number) Mouse x position.
--@param(y : number) Mouse y position.
--@param(button : string) Mouse button pressed (MouseConstant enumeration).
function love.mousepressed(x,y,button)
   input:mousepressed(button)
end

--Callback function triggered when a mouse button is released.
--@param(x : number) Mouse x position.
--@param(y : number) Mouse y position.
--@param(button : string) Mouse button released (MouseConstant enumeration).
function love.mousereleased(x,y,button)

      x, y = cam:toWorld(x,y)
      print(tostring(cWithLevel(x, y))..","..getCTile(x, y))
      input:mousereleased(button)
end

--Callback function triggered when window receives or loses mouse focus.
--@param(f : boolean) True when the window receives mouse focus, false when it loses it.
function love.mousefocus(f)

end

--Callback function triggered when window is minimized/hidden or unminimized by the user.
--@param(v : boolean) true if the window is visible, false otherwise
function love.visible(v)

end


--Callback function triggered when the game is closed.
--@ret(boolean) Whether to abort quitting--if true, do not close the game.
function love.quit()
  return false
end
