--
--
--
player = sprite:new()
--This class is the base class for all graphical objects.
--
--

player.graphic = players.temp
player.xSpeed = 0;
player.ySpeed = 0;
player.gSpeed = 0;
player.gAcc = .51
player.runSpeed = 7;
player.oX = 34
player.oY = 112
player.lBound = -17
player.rBound = 17
player.uBound = -105
player.inAir = false
player.running = false;
player.touchingWall = false;
player.slp = 0;
player.rollingTime = 100
player.offsetX = 0
player.offsetY = 0

player.jumpFrames = 0;
player.jumpFramesMax = 10;
player.jumpChange = .6;
player.tRot = 0;

player.magnet = false

player.magnetDir = 'd'

--
--
--
--

player.anis = lightWorld:newAnimationGrid(player.graphic,100,100)
--player.anis:setNormalMap(players.tempNormal)
player.g = player.anis:newGrid(70, 112)


player.anis:addAnimation('stand',player.g('1-1',1), 0.0167)
player.anis:addAnimation('run',  player.g('10-25',1,'1-17',2), 0.0167)
player.anis:addAnimation('air1', player.g(18,3), 0.0167)
player.anis:addAnimation('air2', player.g(25,3), 0.0167)
player.anis:addAnimation('air3', player.g(6,4), 0.0167)
player.anis:addAnimation('wall', player.g(14,4), 0.0167)
player.anis:addAnimation('wallBack', player.g(1,5), 0.0167)
player.hasAni = true
player.currentAni = "stand"
player.anis:setAnimation(player.currentAni)
player.anis.ix = 0
player.anis.iy = 0

player.wallStuck = false;
player.wallStuckLeft = false
player.wallLookingBack = false

player.jPressed = false;

--SET ANIMATIONS
--player.animations["run"] = anim8.newAnimation(player.g('10-25',1,'1-17',2), 0.04)
--player.animations["stand"] = anim8.newAnimation(player.g('1-1',1), 0.04)
--player.animations["air1"] = anim8.newAnimation(player.g(18,3), 0.04)
--player.animations["air2"] = anim8.newAnimation(player.g(25,3), 0.04)
--player.animations["air3"] = anim8.newAnimation(player.g(6,4), 0.04)

--
--
--

function player:handleCamera(sp)
     for nam, obj in pairs(sp) do
         if obj.properties.doNotFollow then
            if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
               if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then
                  cam:setPosition(cam.x+((-cam.x+(obj.x+(obj.width/2)))/5), cam.y+((-cam.y+(obj.y+(obj.height/2)))/5)   )
                   return
               end
            end
         else

         end
      end
       cam:setPosition( math.floor(cam.x+((-cam.x+self.x+self.oX)/5)),math.floor(cam.y+((-cam.y+self.y+self.oY)/5))   )
end
--
function player:handleMapChanges(sp)
     for nam, obj in pairs(sp) do
         if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
            if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then
               changeMap(obj.properties.toMap, obj.properties.spawner)
               return
            end
         end
      end
end
--
function player:groundLogic(dt)


   if love.keyboard.isDown("right") and self.rollingTime>25 then
      self.faceLeft = false;
      self.gSpeed = self.gSpeed + self.gAcc
      self.running = true
      if self.gSpeed<0 then
         self.gSpeed = self.gSpeed + self.gAcc
      end
      if self.magnet then
         self.gSpeed = 3.6
      end

   elseif love.keyboard.isDown("left") and self.rollingTime>25 then
      self.faceLeft = true;
      self.gSpeed = self.gSpeed - self.gAcc
      self.running = true
      if self.gSpeed>0 then
         self.gSpeed = self.gSpeed - self.gAcc
      end
       if self.magnet then
         self.gSpeed = -3.6
      end
   else
      if self.gSpeed<0 then
         self.gSpeed = self.gSpeed + self.gAcc/1.2
      end
      if self.gSpeed>0 then
         self.gSpeed = self.gSpeed - self.gAcc/1.2
      end
      self.slp = 0
      if self.magnet then
         self.gSpeed = 0
      end
   end



   if input:pressed ("magnet") then
      self.magnet = true
      self.magnetDir = 'd'
   end


   if self.magnet then

   end

   self.gSpeed = limitNum(self.gSpeed, self.runSpeed)

   if self.magnet then
      self.xSpeed = 0
      self.ySpeed = 0
      -- player is attached to walls.
      if self.magnetDir == 'd' then
         self.xSpeed = self.gSpeed
      elseif self.magnetDir == 'u'  then
         self.xSpeed = -self.gSpeed
      elseif self.magnetDir == 'l'  then
         self.ySpeed = self.gSpeed
      elseif self.magnetDir == 'r'  then
         self.ySpeed = -self.gSpeed
      end


   else


      if self.gSpeed>0 then
         self.xSpeed = self.gSpeed*math.cos(getCSlope(self.x+self.oX,self.y+self.oY+3));
         self.ySpeed = -self.gSpeed*math.sin(getCSlope(self.x+self.oX,self.y+self.oY+3));
      else
         self.xSpeed = self.gSpeed*math.cos(getCSlope(self.x+self.oX,self.y+self.oY+3));
         self.ySpeed = self.gSpeed*math.sin(getCSlope(self.x+self.oX,self.y+self.oY+3));
      end


   end

   if input:pressed('jump') and self.magnet == false then
      self.ySpeed = -10
      inAir = true
      self.y = self.y-5
      self.jumpFrames = 0;
   end
end
--
function player:airLogic(dt)


      --Give character slight control of self in the air
   if love.keyboard.isDown("right") then
      if self.xSpeed<self.runSpeed then
         self.xSpeed = self.xSpeed + (self.gAcc/2)
      end
   elseif love.keyboard.isDown("left") then
      if self.xSpeed>-self.runSpeed then
         self.xSpeed = self.xSpeed - (self.gAcc/2)
      end
   else
   end

   if input:down('jump') and self.jumpFrames<self.jumpFramesMax then
      self.ySpeed = self.ySpeed - self.jumpChange
   else
      self.jumpFrames = 1000
   end
   self.ySpeed = self.ySpeed + gravity
   self.jumpFrames = self.jumpFrames + 1
end
--
function  player:wallJumping(dt)
   self.wallLookingBack = false
   if self.inAir then
      if not love.keyboard.isDown("down") then
         if cWithLevel(self.x+self.oX+self.lBound-5, self.y+self.oY-51) and love.keyboard.isDown("left") then
            self.wallStuck = true
            self.wallStuckLeft = true
            self.faceLeft = true;
         elseif cWithLevel(self.x+self.oX+self.rBound+5, self.y+self.oY-51) and love.keyboard.isDown("right") then
            self.wallStuck = true
            self.faceLeft = false;
            self.wallStuckLeft = false
         end
      end
      if self.wallStuck then
         if self.ySpeed>2 then self.ySpeed = 2 end
            if( love.keyboard.isDown("down")) then
               self.wallStuck = false
            end
         if self.wallStuckLeft then
            if love.keyboard.isDown("right") then
               self.wallLookingBack = true
            end
            if input:pressed('jump') then
               self.xSpeed = 7
               self.ySpeed = -9
               self.jumpFrames = 6
               self.wallStuck = false
               self.faceLeft = false;
            end
         end
         if not self.wallStuckLeft then
            if love.keyboard.isDown("left") then
               self.wallLookingBack = true
            end
            if input:pressed('jump') then
               self.xSpeed = -7
               self.ySpeed = -9
               self.jumpFrames = 6
               self.wallStuck = false
               self.faceLeft = true;
            end
         end
         if not cWithLevel(self.x+self.oX+self.lBound-6, self.y+self.oY-51) and not cWithLevel(self.x+self.oX+self.rBound+6, self.y+self.oY-51) then
            self.wallStuck = false
         end
      end
   else
      self.wallStuck = false
   end
end
--
function player:rolling(dt)
   self.rollingTime = self.rollingTime + 1
   if input:pressed("roll") and not self.inAir and self.rollingTime>40 and not self.magnet then
      self.rollingTime = 0;
       self.ySpeed = 0
      self.y = self.y-3
      if self.faceLeft then
         self.xSpeed = -10
      else
         self.xSpeed = 10
      end
   end
    if self.rollingTime<23 then
      if self.faceLeft then
         self.gSpeed = -4
         self.xSpeed = -4
      else
         self.gSpeed = 4
         self.xSpeed = 4
      end
   end
    if self.rollingTime<13 then
      if self.faceLeft then
         self.gSpeed = -10
         self.xSpeed = -10
      else
         self.gSpeed = 10
         self.xSpeed = 10
      end
   end
    if self.rollingTime<2 then
      if self.faceLeft then
         self.gSpeed = -4
         self.xSpeed = -4
      else
         self.gSpeed = 4
         self.xSpeed = 4
      end
   end


end


--Logic for magnets
--very complex so seperated to it's own module
require('pLogic.magnet')


function player:walls(dt)
   while cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-85) do
      self.gSpeed = 0
      self.xSpeed = 0
      self.x = self.x+self.gAcc
      self.touchingWall = true
   end

   while cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-85) do
      self.gSpeed = 0
      self.xSpeed = 0
      self.x = self.x-self.gAcc
      self.touchingWall = true
   end


   while cWithLevel(self.x+self.oX+10, self.y+self.oY+self.uBound) or
         cWithLevel(self.x+self.oX-10, self.y+self.oY+self.uBound) do
      if self.ySpeed<0 then
          self.ySpeed = 0
      end
      self.jumpFrames = 1000

      self.y = self.y+1

   end
end
--
function player:update(dt)

      self.touchingWall = false


      if math.abs(self.xSpeed) <.1 then
         self.xSpeed = 0
      end
      if math.abs(self.ySpeed) <.1 then
         self.ySpeed = 0
      end

      self.running = false

      -- actions for not being in the air!
      if not self.inAir then
         self:groundLogic(dt)
      end



      ---THis is what to do when the character is in the air.
      if self.inAir then
         self:airLogic(dt)
      end

      if self.wallStuck then
         self.xSpeed = 0;
      end

      self:rolling(dt);
      self.x = math.rd(self.x + math.rd(self.xSpeed))
      self.y = math.rd(self.y + math.rd(self.ySpeed))



      if self.ySpeed > maxFall then
         self.ySpeed = maxFall
      end

      if not self.magnet then
         while (cWithLevel(self.x+self.oX-13,self.y+self.oY) or  cWithLevel(self.x+self.oX+13,self.y+self.oY) ) and self.ySpeed>=0 do
            self.ySpeed = 0
            self.y = self.y-1
         end

         if  (cWithLevel(self.x+self.oX-13,self.y+self.oY+7) or cWithLevel(self.x+self.oX+13,self.y+self.oY+7)) and self.ySpeed>=0  then
            if self.inAir then self.gSpeed = self.xSpeed end
            self.inAir = false
            while not cWithLevel(self.x+self.oX-13,self.y+self.oY) and not cWithLevel(self.x+self.oX+13,self.y+self.oY)  do
               self.y = self.y+1
            end
         else
            self.inAir = true
         end
      end

      if not self.magnet then
         self:wallJumping(dt)
         self:walls();
      else
         self:magnets( dt );
         self.inAir = false;
      end


      if not self.inAir and self.running and self.touchingWall == false then
         self.currentAni = "run"
      elseif self.inAir then
         if self.wallStuck then
            if self.wallLookingBack then
               self.currentAni = "wallBack"
            else
               self.currentAni = "wall"
            end
         else
            if self.ySpeed > 5 then
             self.currentAni = "air3"
            elseif self.ySpeed < -5 then
               self.currentAni = "air1"
            else
               self.currentAni = "air2"
            end
         end
      else
         self.currentAni = "stand"
      end
      self:handleCamera(curMap.layers.cam.objects)
      self:handleMapChanges(curMap.layers.mapChange.objects)
      self.anis:setAnimation(self.currentAni)

end




function player:getSkiPosition(tx,ty)
   local tile = getCTile(tx,ty)
   local col = 0,0


   if tile == 2 then col = 0,0

   --Regular slopes
   --
   elseif tile == 3  then col = 1,2
   elseif tile == 4  then col = math.atan2(-3,3)
   elseif tile == 5  then col = math.atan2(3,3)
   elseif tile == 6  then col = math.atan2(-3,3)
   --Half Slopes
   --
   elseif tile == 9  then col = math.atan2(1.5,3)
   elseif tile == 10 then col = math.atan2(1.5,3)
   elseif tile == 11 then col = math.atan2(-1.5,3)
   elseif tile == 12 then col = math.atan2(-1.5,3)
   --Quarter Slopes
   --
   elseif tile == 17 then col = math.atan2(.75,3)
   elseif tile == 18 then col = math.atan2(.75,3)
   elseif tile == 19 then col = math.atan2(.75,3)
   elseif tile == 20 then col = math.atan2(.75,3)

   elseif tile == 21 then col = math.atan2(-.75,3)
   elseif tile == 22 then col = math.atan2(-.75,3)
   elseif tile == 23 then col = math.atan2(-.75,3)
   elseif tile == 24 then col = math.atan2(-.75,3)

   elseif tile == 25 then col = math.atan2(3,3)
   elseif tile == 26 then col = math.atan2(-3,3)


   elseif tile == 27 then col = math.atan2(1.5,3)
   elseif tile == 28 then col = math.atan2(.75,3)

   elseif tile == 29 then col = math.atan2(-.75,3)
   elseif tile == 30 then col = math.atan2(-1.5,3)
   end

   return col
end
